/***************************************************
//Web: http://www.buydisplay.com
EastRising Technology Co.,LTD
****************************************************/
#include <SPI.h>
#include "er_oled.h"


void OLED_WR_Byte(uint8_t dat,uint8_t cmd)
{	
	if(cmd)
	  digitalWrite(OLED_DC, HIGH);
	else 
	  digitalWrite(OLED_DC, LOW);
	digitalWrite(OLED_CS1, LOW);
	digitalWrite(OLED_CS2, LOW);
        SPI.transfer(dat);			 		  
	digitalWrite(OLED_CS1, HIGH);
	digitalWrite(OLED_CS2, HIGH);
	digitalWrite(OLED_DC, HIGH);	  
}

void OLED_WR_Byte1(uint8_t dat,uint8_t cmd,uint8_t mode)
{	
	if(cmd)
	   digitalWrite(OLED_DC, HIGH);
	else 
	   digitalWrite(OLED_DC, LOW);
	if(mode==1)digitalWrite(OLED_CS1, LOW);
	if(mode==2)digitalWrite(OLED_CS2, LOW);
        SPI.transfer(dat);
	if(mode==1)digitalWrite(OLED_CS1, HIGH);
	if(mode==2)digitalWrite(OLED_CS2, HIGH);
	  digitalWrite(OLED_DC, HIGH);
}



void er_oled_begin()
{
  pinMode(OLED_RST, OUTPUT);
  pinMode(OLED_DC, OUTPUT);
  pinMode(OLED_CS1, OUTPUT);
   pinMode(OLED_CS2, OUTPUT); 
  SPI.begin();
    
  SPI.setClockDivider(SPI_CLOCK_DIV128);
    
  digitalWrite(OLED_CS1, LOW);
   digitalWrite(OLED_CS2, LOW); 
  digitalWrite(OLED_RST, HIGH);
  delay(10);
  digitalWrite(OLED_RST, LOW);
  delay(10);
  digitalWrite(OLED_RST, HIGH);
   
	OLED_WR_Byte(0xae,OLED_CMD);//Display OFF 
	OLED_WR_Byte(0xfd,OLED_CMD);//Set Command Lock 
	OLED_WR_Byte(0x12,OLED_CMD); 
	OLED_WR_Byte(0x20,OLED_CMD);//Set Memory Addressing Mode 
	OLED_WR_Byte(0x00,OLED_CMD); 
	OLED_WR_Byte(0x25,OLED_CMD);//Set Portrait Addressing Mode 
	OLED_WR_Byte(0x00,OLED_CMD);//Normal Addressing Mode 
	OLED_WR_Byte(0x81,OLED_CMD);//Set Contrast Control 
	OLED_WR_Byte(0x6b,OLED_CMD); 
	OLED_WR_Byte1(0xa0,OLED_CMD,1);//Set Seg Remap
	OLED_WR_Byte1(0xa1,OLED_CMD,2);
	OLED_WR_Byte(0xa2,OLED_CMD);//Set Display Start Line 
	OLED_WR_Byte(0x00,OLED_CMD); 
	OLED_WR_Byte(0xa4,OLED_CMD);//Resume to RAM content display 
	OLED_WR_Byte(0xa6,OLED_CMD);//Set Normal Display 
	OLED_WR_Byte(0xa8,OLED_CMD);//Set MUX Ratio 
	OLED_WR_Byte(0x83,OLED_CMD);//1/132 duty 
	OLED_WR_Byte(0xad,OLED_CMD);//Select external or internal IREF 
	OLED_WR_Byte(0x10,OLED_CMD); 
	OLED_WR_Byte(0xbc,OLED_CMD);//Set Pre-charge voltage 
	OLED_WR_Byte(0x1e,OLED_CMD);// 
	OLED_WR_Byte(0xbf,OLED_CMD);//Linear LUT 
	OLED_WR_Byte1(0xc8,OLED_CMD,1);//Set COM Output Scan Direction 
	OLED_WR_Byte1(0xc0,OLED_CMD,2);
	OLED_WR_Byte(0xd3,OLED_CMD);//Set Display Offset 
	OLED_WR_Byte1(0x0e,OLED_CMD,1); 
	OLED_WR_Byte1(0x92,OLED_CMD,2); 
	OLED_WR_Byte(0xd5,OLED_CMD);//Set Display Clock Divide Ratio/Oscillator Frequency 
	OLED_WR_Byte(0xc2,OLED_CMD);//85Hz 
	OLED_WR_Byte(0xd9,OLED_CMD);//Set Pre-charge Period 
	OLED_WR_Byte(0x72,OLED_CMD);// 
	OLED_WR_Byte(0xda,OLED_CMD);//Set SEG Pins Hardware Configuration 
	OLED_WR_Byte(0x32,OLED_CMD);
	OLED_WR_Byte(0xbd,OLED_CMD);//Set VP 
	OLED_WR_Byte(0x03,OLED_CMD); 
	OLED_WR_Byte(0xdb,OLED_CMD);//Set VCOMH 
	OLED_WR_Byte(0x30,OLED_CMD);
	OLED_Clear(0,0,320,132,0x00);
	OLED_WR_Byte(0xaf,OLED_CMD);//Display on

}

void OLED_Address_Set1(uint16_t x1,uint16_t x2,uint16_t y1,uint16_t y2,uint8_t t)
{
	if(x2<80)
	{
		OLED_WR_Byte1(0x21,OLED_CMD,t);
		OLED_WR_Byte1(x1,OLED_CMD,t);
		OLED_WR_Byte1(x2,OLED_CMD,t);
		OLED_WR_Byte1(0x22,OLED_CMD,t);
		OLED_WR_Byte1(y1,OLED_CMD,t);
		OLED_WR_Byte1(y2,OLED_CMD,t);
	}
	else
	{
		OLED_WR_Byte1(0x21,OLED_CMD,1);
		OLED_WR_Byte1(x1,OLED_CMD,1);
		OLED_WR_Byte1(79,OLED_CMD,1);
		OLED_WR_Byte1(0x22,OLED_CMD,1);
		OLED_WR_Byte1(y1,OLED_CMD,1);
		OLED_WR_Byte1(y2,OLED_CMD,1);
		
		OLED_WR_Byte1(0x21,OLED_CMD,2);
		OLED_WR_Byte1(0,OLED_CMD,2);
		OLED_WR_Byte1(x2-80,OLED_CMD,2);
		OLED_WR_Byte1(0x22,OLED_CMD,2);
		OLED_WR_Byte1(y1,OLED_CMD,2);
		OLED_WR_Byte1(y2,OLED_CMD,2);
	}
}

void OLED_Clear(uint16_t x1,uint16_t y1,uint16_t x2,uint16_t y2,uint8_t color)
{
	uint8_t j,t=0,sizex;
	uint16_t i,xt=0;
	x1/=2;
	x2/=2;
	sizex=x2-x1;
	if(x1<80)t=1;
	else
  {
		t=2;
		x1-=80;
	}
	OLED_Address_Set1(x1,x2-1,y1,y2-1,t);
	for(i=x1;i<x2;i++)
	{
		for(j=y1;j<y2;j++)
		{
			OLED_WR_Byte1(color,OLED_DATA,t);
			if((x1+sizex-1)>79)
			{
				xt++;
				if(xt==sizex) xt=0;
				if(xt+x1>79) t=2;
				else t=1;
			}
	  }
	}
}





void Data_processing(uint8_t  temp,uint8_t  t)   //turns 1byte B/W data to 4 bye gray data  with 8 Pixel
{uint8_t temp1,temp2;

  if(temp&0x80)temp1=0xf0;
  else temp1=0x00;
  if(temp&0x40)temp2=0x0f;
  else temp2=0x00;
  temp1=temp1|temp2;
  OLED_WR_Byte1(temp1,OLED_DATA,t); //Pixel1,Pixel2 
  if(temp&0x20)temp1=0xf0;
  else temp1=0x00;
  if(temp&0x10)temp2=0x0f;
  else temp2=0x00;
  temp1=temp1|temp2;
  OLED_WR_Byte1(temp1,OLED_DATA,t);   //Pixel3,Pixel4           
  if(temp&0x08)temp1=0xf0;
  else temp1=0x00;
  if(temp&0x04)temp2=0x0f;
  else temp2=0x00;
  temp1=temp1|temp2;
  OLED_WR_Byte1(temp1,OLED_DATA,t);   //Pixel5,Pixel6 
  if(temp&0x02)temp1=0xf0;
  else temp1=0x00;
  if(temp&0x01)temp2=0x0f;
  else temp2=0x00;
  temp1=temp1|temp2;
  OLED_WR_Byte1(temp1,OLED_DATA,t);  //Pixel7,Pixel8  
}

void OLED_ShowPicture_mono(uint16_t x,uint16_t y,uint16_t sizex,uint16_t sizey,const uint8_t bmp[])
{
	uint8_t t=0;
	uint8_t DATA1=0;
	uint16_t i,num,xt=0;
	x/=2;
	if(x<80)t=1;
	else
  {
		t=2;
		x-=80;
	}
	OLED_Address_Set1(x,x+sizex/2-1,y,y+sizey-1,t);
	num=sizex*sizey/8;
	for(i=0;i<num;i++)
	{
		DATA1=bmp[i];
		Data_processing(DATA1,t);
		
		DATA1=0;
		if((x+sizex/2-1)>79)
		{
			xt+=4;
			if(xt==sizex/2) xt=0;
			if(xt+x>79) t=2;
			else t=1;
		}
	}
}


void OLED_ShowPicture_gray(uint16_t x,uint16_t y,uint16_t sizex,uint16_t sizey,const uint8_t bmp[])
{
	uint8_t t=0;
	uint8_t DATA1=0;
	uint16_t i,num,xt=0;
	x/=2;
	if(x<80)t=1;
	else
  {
		t=2;
		x-=80;
	}
	OLED_Address_Set1(x,x+sizex/2-1,y,y+sizey-1,t);
	num=sizex*sizey/2;
	for(i=0;i<num;i++)
	{
		DATA1=bmp[i];
		OLED_WR_Byte1(DATA1,OLED_DATA,t);
		DATA1=0;
		if((x+sizex/2-1)>79)
		{
			xt++;
			if(xt==sizex/2) xt=0;
			if(xt+x>79) t=2;
			else t=1;
		}
	}
}


